function y=model(cho, del_t, sim_time, tau,SP,u,d)

global h y_m y_mf A Kp Ti plt  

int=0;
B=y_mf(1);
C=SP(1);
xa=[1];

 plt = plot(xa,B,xa,C,'--');
 plt(1).YDataSource='B';
 plt(2).YDataSource='C'; 
 plt(1).XDataSource='xa';
 plt(2).XDataSource='xa';

for i=2:sim_time/del_t
    
    % Controller update
    if cho~=1
    error=-SP(i)+y_mf(i-1);
    int=int+error*del_t;
    u(i)=Kp*error+Kp/Ti*int;
    end
    
    % Process update
    dh_dt=1/A*(d(i)-u(i));
    h(i)=h(i-1)+dh_dt*del_t;
    
    % Measurement Noise
    noise=0.01;
    y_m(i)=h(i)+noise*rand;
    
    % Filter
    alpha=del_t/(del_t+tau);
    y_mf(i)=(alpha)*y_m(i)+(1-alpha)*y_mf(i-1);
    
    if h(i)>=2  %(the simulator stops when the tank is full)
        y_m(i)=2;
        y_mf(i)=2;
    end
    
    if h(i)<= 0 %(the simulator stops when the tank is full)
        y_m(i)=0;
        y_mf(i)=0;
    end
    
    %% creating dynamic plot for measured value
    if i>700
    B=y_mf(i-700:i);
    C=SP(i-700:i);
    xa=[1+i:1:701+i];
    refreshdata(plt,'caller');
    axis([i 701+i 0 2]);
    drawnow
    end
    
end
y=[y_m;y_mf;u];
end
